#include <X11/Xlib.h>
#include <X11/Intrinsic.h>

#include "./logo/a.xbm"   
#include "./logo/f.xbm"   
#include "./logo/l.xbm"   
#include "./logo/o.xbm" 
#include "./logo/t.xbm"  
#include "./logo/u.xbm"

#define LOGO_X 40
#define LOGO_Y 320
#define DELAY  5
#define DX     10
#define DY     10


extern Display *display;
extern Widget  canvas;
extern GC      lineGC;

static Pixmap pmap;
static int go_on;

#define SHOW_LETTER(bits,w,h,x) 			\
	pmap=XCreateBitmapFromData(XtDisplay(canvas), XtWindow(canvas),bits,w,h);\
        go_on=drop(pmap,w,h,x,LOGO_Y);                  \
        XFreePixmap(display,pmap);			\
        if(go_on==False) return;



static drop(let,width,height,x,y)
Pixmap let;
int width,height,x,y;
{
  register int j,pj;
  XEvent event;

	for(pj=j=0; j<y; pj=j,j+=DY){
		if(XCheckWindowEvent(display,XtWindow(canvas),
				KeyPressMask|ButtonPressMask,&event)==True){
			XSync(display,True);
			XPutBackEvent(display,event);
			XClearArea(XtDisplay(canvas), XtWindow(canvas), 
					0, 0, 300, 600, FALSE);
			return False;
		}

		XClearArea(display,XtWindow(canvas),x,pj-height,width,height,False);
		XCopyPlane(display,let,XtWindow(canvas),lineGC,0,0,width,height,
			x,j-height,1L);
		XFlush(display);
		usleep(DELAY);
	}

	return True;
}


show_logo()
{
 register int x=LOGO_X;
	
	SHOW_LETTER(f_bits,f_width,f_height,x);
	x+=f_width+DX;

	SHOW_LETTER(a_bits,a_width,a_height,x);
	x+=a_width+DX;

	pmap=XCreateBitmapFromData(XtDisplay(canvas), XtWindow(canvas),l_bits,l_width,l_height);
        drop(pmap,l_width,l_height,x,LOGO_Y);               
	x+=l_width+DX;
	drop(pmap,l_width,l_height,x,LOGO_Y);
	x+=l_width+DX;
	XFreePixmap(display,pmap);

	SHOW_LETTER(o_bits,o_width,o_height,x);
	x+=o_width+DX;

	SHOW_LETTER(u_bits,u_width,u_height,x);
	x+=u_width+DX;

	SHOW_LETTER(t_bits,t_width,t_height,x);
	x+=t_width+DX;
}
