#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <time.h>
#include <unistd.h>
#include <X11/IntrinsicP.h>
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

#include "xfallout.h"

static FILE *fp;

extern int score;
extern Widget canvas;

static struct score {
	char name[40];
	int score;
	long date;
	struct score *next;
	} scores[5];

static struct timeval tm;

void read_scores_and_show()
{
	int i = 0;
	int k;
	char line[80];
	if(!(fp = fopen(SCOREFILEPATH,"r"))) {
		XClearArea(XtDisplay(canvas), XtWindow(canvas),0,400,300,200,FALSE);
		print_string("NO HIGH SCORE FILE FOUND",50,500);
		return;
	}
	bzero(scores,sizeof(scores));
	while(fscanf(fp,"%s %d %d\n",scores[i].name,&scores[i].score,&scores[i].date) != EOF)
		i++;
	XClearArea(XtDisplay(canvas), XtWindow(canvas),0,400,300,200,FALSE);
	print_string("HIGH SCORES",100,420);
	for(k=0;k<i;k++) {
		char buf[26];

		strftime(buf,26,"%d %h %y",gmtime(&scores[k].date));
		sprintf(line,"%-8s %-5d %s",scores[k].name,scores[k].score,buf);
		print_string(line,50,440+15*(k+1));
	}
	fclose(fp);
	usleep(400000);
	return;
}

void show_scores_and_update()
{
	int i;
	int changed = 0;
	char line[80];
	
	if(!(fp = fopen(SCOREFILEPATH,"w"))) {
		XClearArea(XtDisplay(canvas), XtWindow(canvas),0,390,300,210,FALSE);
		print_string("NO HIGH SCORE FILE FOUND",100,500);
		usleep(400000);
		return;
	}
	if(score > scores[4].score) {
		changed = 1;
		strcpy(scores[4].name,getlogin());
		scores[4].score = score;
		gettimeofday(&tm,NULL);
		scores[4].date = tm.tv_sec;
		for(i=4;i>0;i--)
			if(scores[i-1].score < scores[i].score) {
				char name[40];
				int score;
				int date;

				strcpy(name,scores[i-1].name);
				strcpy(scores[i-1].name,scores[i].name);
				strcpy(scores[i].name,name);
				score = scores[i-1].score;
				scores[i-1].score = scores[i].score;
				scores[i].score = score;
				date = scores[i-1].date;
				scores[i-1].date = scores[i].date;
				scores[i].date = date;
			}
	}
	if((changed) && (fp != NULL))
		for(i=0;((i<5) && (scores[i].score != 0));i++)
			fprintf(fp,"%s %d %d\n",scores[i].name,scores[i].score,scores[i].date);
	XClearArea(XtDisplay(canvas), XtWindow(canvas),0,390,300,210,FALSE);
	print_string("HIGH SCORES",100,420);
	for(i=0;(i<5 && scores[i].score != 0);i++) {
		char buf[26];

		strftime(buf,26,"%d %h %y",gmtime(&scores[i].date));
		sprintf(line,"%-8s %-5d %s",scores[i].name,scores[i].score,buf);
		print_string(line,50,420 + 15*(i+1));
	}
	usleep(1000000);
	close(fp);
	return;
}
